#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#include <iomanip>
#include <numeric>
#include <queue>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';


lli arr[902][902];
lli minarr[902][902];
lli used[902][902];
const lli INF = 1e18;

struct cell
{
    lli row, col;
};

struct node
{
    lli val, row, col;
};


lli findmin(lli n, lli m)
{
    lli tres = INF;
    for (int i = 1; i <= n; i++)tres = min(tres, minarr[i][1]);
    for (int i = 1; i <= n; i++)tres = min(tres, minarr[i][m]);
    for (int j = 1; j <= m; j++)tres = min(tres, minarr[1][j]);
    for (int j = 1; j <= m; j++)tres = min(tres, minarr[n][j]);
    return tres;
}

void updatebfs(cell from, cell to, queue<cell>& q,lli n,lli m)
{
    if (to.row<1 || to.row>n || to.col<1 || to.col>m)return;
    lli tres = max(arr[to.row][to.col],minarr[from.row][from.col]);
    if (minarr[to.row][to.col] > tres)q.push(to);
    minarr[to.row][to.col] = min(tres, minarr[to.row][to.col]);
}


lli bfs(lli row, lli col,lli n,lli m)
{
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++)minarr[i][j] = INF;
    }
    queue<cell> q;
    q.push({ row,col });
    minarr[row][col] = arr[row][col];
    while (!q.empty()) {
        cell a = q.front();
        q.pop();
        updatebfs(a, { a.row + 1,a.col },q,n,m);
        updatebfs(a, { a.row - 1,a.col },q,n,m);
        updatebfs(a, { a.row, a.col +1},q,n,m);
        updatebfs(a, { a.row,a.col-1 },q,n,m);
    }

    return findmin(n,m);
}


void updatedx3(node from, node to, priority_queue<pair<lli, lli>, vector<pair<lli, lli>>, greater<pair<lli, lli>>>& q , lli n, lli m)
{
    if (to.row<1 || to.row>n || to.col<1 || to.col>m)return;
    lli tres = max(arr[to.row][to.col], minarr[from.row][from.col]);
    if (minarr[to.row][to.col] > tres)q.push({ tres,to.row*10000+to.col });
    minarr[to.row][to.col] = min(tres, minarr[to.row][to.col]);
}


lli dx3(lli row, lli col, lli n, lli m)
{
    priority_queue<pair<lli,lli>, vector<pair<lli,lli>>, greater<pair<lli,lli>>> pq;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            minarr[i][j] = INF;
            used[i][j] = 0;
        }
    }
    pq.push({ arr[row][col],row*10000+col });
    minarr[row][col] = arr[row][col];

    while (!pq.empty()) {
        lli x = pq.top().second;
        node a;
        a.val = pq.top().first;
        a.col = x % 1000;
        a.row = (x - a.col) / 10000;
        pq.pop();
        if (used[a.row][a.col] == 1)continue;
        used[a.row][a.col] = 1;
        updatedx3(a, { a.val,a.row + 1,a.col }, pq, n, m);
        updatedx3(a, { a.val, a.row - 1,a.col }, pq, n, m);
        updatedx3(a, { a.val, a.row, a.col + 1 }, pq, n, m);
        updatedx3(a, { a.val,a.row,a.col - 1 }, pq, n, m);
    }



    return findmin(n, m);
}




lli update(lli row, lli col, lli h,lli n,lli m)
{
    lli res = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (minarr[i][j]<h){
                res += h - arr[i][j];
                arr[i][j] = h;
            }
        }
    }
    return res;
}

lli func(lli row, lli col,lli n,lli m)
{
//    lli maxh = bfs(row, col,n, m);
    lli maxh = dx3(row, col, n, m);
    lli res = update(row, col, maxh,n,m);
    return res;
}

void solve()
{
    lli n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> arr[i][j];
        }
    }

    lli ans = 0;
    for (int i = 2; i < n; i++) {
        for (int j = 2; j < m; j++) {
            ans += func(i, j,n,m);
        }
    }
    cout << ans;
}


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

