#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#include <iomanip>
#include <numeric>
#include <queue>

using namespace std;

typedef int lli;
typedef long double ld;
#define LF '\n';


struct cell
{
    lli row, col;
};

struct node
{
    lli val, row, col;
};



lli arr[902][902];
lli minarr[902][902];
lli used[902][902];
vector<node> bestb;
const lli INF = 1e18;


bool cmp(node a1, node a2)
{
    return a1.val < a2.val;
}

lli findmin(lli n, lli m)
{
    lli tres = INF;
    for (int i = 1; i <= n; i++)tres = min(tres, minarr[i][1]);
    for (int i = 1; i <= n; i++)tres = min(tres, minarr[i][m]);
    for (int j = 1; j <= m; j++)tres = min(tres, minarr[1][j]);
    for (int j = 1; j <= m; j++)tres = min(tres, minarr[n][j]);
    return tres;
}


void updatedx3(node from, node to, priority_queue<pair<lli, lli>, vector<pair<lli, lli>>, greater<pair<lli, lli>>>& q , lli n, lli m)
{
    if (to.row<1 || to.row>n || to.col<1 || to.col>m)return;
    lli tres = max(arr[to.row][to.col], minarr[from.row][from.col]);
    if (minarr[to.row][to.col] > tres)q.push({ tres,to.row*10000+to.col });
    minarr[to.row][to.col] = min(tres, minarr[to.row][to.col]);
}


lli dx3(lli row, lli col, lli n, lli m)
{
    priority_queue<pair<lli,lli>, vector<pair<lli,lli>>, greater<pair<lli,lli>>> pq;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
//            minarr[i][j] = INF;
            used[i][j] = 0;
        }
    }
    pq.push({ arr[row][col],row*10000+col });
    minarr[row][col] = arr[row][col];

    while (!pq.empty()) {
        lli x = pq.top().second;
        node a;
        a.val = pq.top().first;
        a.col = x % 1000;
        a.row = (x - a.col) / 10000;
        pq.pop();
        if (used[a.row][a.col] == 1)continue;
        used[a.row][a.col] = 1;
        updatedx3(a, { a.val,a.row + 1,a.col }, pq, n, m);
        updatedx3(a, { a.val, a.row - 1,a.col }, pq, n, m);
        updatedx3(a, { a.val, a.row, a.col + 1 }, pq, n, m);
        updatedx3(a, { a.val,a.row,a.col - 1 }, pq, n, m);
    }



    return findmin(n, m);
}



lli update(lli h,lli n,lli m)
{
    lli res = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (minarr[i][j]<h){
                res += h - arr[i][j];
                arr[i][j] = h;
            }
        }
    }
    return res;
}

lli func(lli row, lli col,lli n,lli m)
{
    lli maxh = dx3(row, col, n, m);
    lli res = update(maxh,n,m);
    return res;
}

void solve()
{
    lli n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> arr[i][j];
        }
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
              minarr[i][j] = INF;
            //used[i][j] = 0;
        }
    }

    for (int i = 1; i <= n; i++)bestb.push_back({ arr[i][1],i, 1 });
    for (int i = 1; i <= n; i++)bestb.push_back({arr[i][m], i, m });
    for (int j = 1; j <= m; j++)bestb.push_back({arr[1][j], 1, j });
    for (int j = 1; j <= m; j++)bestb.push_back({arr[n][j], n, j });
    sort(bestb.begin(), bestb.end(), cmp);
    for (int i = 0; i < min((lli)1200, (lli)bestb.size()); i++)dx3(bestb[i].row, bestb[i].col, n, m);
    lli ans = 0;
    for (int i = 1; i <= n; i++)for (int j = 1; j <= m; j++)ans += minarr[i][j] - arr[i][j];
    cout << ans;
}


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

