#include <bits/stdc++.h>
using namespace std;
using ll = long long;

ll n, m, q, k, x, y, a, b, c;

struct dsu {
    ll num;
    vector<ll> par;
    vector<ll> sz;
    dsu(ll N) {
        num = N;
        par.resize(N);
        sz.resize(N);
        for (int i = 0; i < num; i++) {
            par[i] = i;
            sz[i] = 1;
        }
    }

    ll find_p(ll x) {
        if (par[x] == x) {
            return x;
        }
        ll p = find_p(par[x]);
        par[x] = p;
        return p;
    }

    void join(ll x, ll y) {
        x = find_p(x);
        y = find_p(y);
        if (x == y) {
            return;
        }
        if (sz[y] > sz[x]) {
            swap(x, y);
        }
        par[y] = x;
        sz[x] += sz[y];
    }

    ll num_sink() {
        return sz[find_p(num - 1)] - 1;
    }
};

ll hsh(pair<ll, ll> p) {
    return p.first * m + p.second;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    vector< vector<ll> > w(n, vector<ll>(m));
    map< ll, vector< pair<ll, ll> > > mp;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> w[i][j];
            mp[w[i][j]].push_back({i, j});
        }
    }
    vector<ll> h;
    for (auto &i : mp) {
        h.push_back(i.first);
    }
    h.push_back(1000000001);
    set< pair<ll, ll> > st;
    ll pos = 0;
    dsu d(n * m + 1);
    ll ans = 0;
    for (auto &i : mp) {
        pos++;
        for (auto j : i.second) {
            if (j.first == 0) {
                d.join(hsh(j), n * m);
            }
            else if (st.count({j.first - 1, j.second})) {
                d.join(hsh(j), hsh({j.first - 1, j.second}));
            }
            if (j.second == 0) {
                d.join(hsh(j), n * m);
            }
            else if (st.count({j.first, j.second - 1})) {
                d.join(hsh(j), hsh({j.first, j.second - 1}));
            }
            if (j.first == n - 1) {
                d.join(hsh(j), n * m);
            }
            else if (st.count({j.first + 1, j.second})) {
                d.join(hsh(j), hsh({j.first + 1, j.second}));
            }
            if (j.second == m - 1) {
                d.join(hsh(j), n * m);
            }
            else if (st.count({j.first, j.second + 1})) {
                d.join(hsh(j), hsh({j.first, j.second + 1}));
            }
            st.insert(j);
        }
        ans += (h[pos] - h[pos - 1]) * (st.size() - d.num_sink());
    }
    cout << ans << '\n';
}