#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2,tune=native")
using namespace std;
using ll = long long;

ll n, m, q, k, x, y, a, b, c;

struct dsu {
    ll num;
    vector<ll> par;
    vector<ll> sz;
    dsu(ll N) {
        num = N;
        par.resize(N);
        sz.resize(N);
        for (int i = 0; i < num; i++) {
            par[i] = i;
            sz[i] = 1;
        }
    }

    ll find_p(ll x) {
        if (par[x] == x) {
            return x;
        }
        ll p = find_p(par[x]);
        par[x] = p;
        return p;
    }

    void join(ll x, ll y) {
        x = find_p(x);
        y = find_p(y);
        if (x == y) {
            return;
        }
        if (sz[y] > sz[x]) {
            swap(x, y);
        }
        par[y] = x;
        sz[x] += sz[y];
    }

    ll num_sink() {
        return sz[find_p(num - 1)] - 1;
    }
};

inline ll hsh(pair<ll, ll> p) {
    return p.first * m + p.second;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    vector< vector<ll> > w(n, vector<ll>(m));
    vector< pair<ll, pair<ll, ll> > > mp;
    mp.reserve(n * m + 1);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> w[i][j];
            // w[i][j] = rand();
            // mp[w[i][j]].push_back({i, j});
            mp.push_back({w[i][j], {i, j}});
        }
    }
    sort(mp.begin(), mp.end());
    unordered_set<ll> st;
    ll pos = 0;
    dsu d(n * m + 1);
    ll ans = 0;
    for (int i = 0; i < n * m - 1; i++) {
        auto j = mp[i].second;
        if (j.first == 0) {
            d.join(hsh(j), n * m);
        }
        else if (st.count(hsh({j.first - 1, j.second}))) {
            d.join(hsh(j), hsh({j.first - 1, j.second}));
        }
        if (j.second == 0) {
            d.join(hsh(j), n * m);
        }
        else if (st.count(hsh({j.first, j.second - 1}))) {
            d.join(hsh(j), hsh({j.first, j.second - 1}));
        }
        if (j.first == n - 1) {
            d.join(hsh(j), n * m);
        }
        else if (st.count(hsh({j.first + 1, j.second}))) {
            d.join(hsh(j), hsh({j.first + 1, j.second}));
        }
        if (j.second == m - 1) {
            d.join(hsh(j), n * m);
        }
        else if (st.count(hsh({j.first, j.second + 1}))) {
            d.join(hsh(j), hsh({j.first, j.second + 1}));
        }
        st.insert(hsh(j));
        if (mp[i + 1].first != mp[i].first) {
            ans += (mp[i + 1].first - mp[i].first) * (st.size() - d.num_sink());
        }
    }
    cout << ans << '\n';
}