#include <iostream>
#include <vector>
#include <string> 
#include <algorithm>
#include <queue>
#include <set>

using namespace std;
typedef long long ll;

const int e9 = 1'000'000'000;
int n, m;
vector<pair<int, int>> dir = { {0, 1}, {1, 0}, {0, -1}, {-1, 0} };
priority_queue<pair<int, pair<int, int>>, vector<pair<int, pair<int, int>>>, greater<>> tbc;
vector<vector<bool>> was, kr;

void bfs(const vector<vector<int>>& mp, vector<vector<int>>& ans) {
	pair<int, int> st = tbc.top().second;
	tbc.pop();
	int lvl = mp[st.first][st.second];
	if (ans[st.first][st.second] != e9 + 1)
		return;
	ans[st.first][st.second] = lvl;
	queue<pair<int, int>> q;
	q.push(st);
	while (!q.empty()) {
		auto tp = q.front();
		q.pop();
		int x = tp.first;
		int y = tp.second;
		for (auto w : dir) {
			int nx = x + w.first;
			int ny = y + w.second;
			if (nx < 0 || nx >= n || ny < 0 || ny >= m)
				continue;
			if (ans[nx][ny] != e9 + 1)
				continue;
			if (mp[nx][ny] > lvl) {
				tbc.push({ mp[nx][ny], {nx, ny} });
				continue;
			}
			ans[nx][ny] = lvl;
			q.push({ nx, ny });
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	vector<vector<int>> mp(n, vector<int>(m));
	vector<vector<int>> ans(n, vector<int>(m, e9 + 1));
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			cin >> mp[i][j];
			if (!i || !j || i == n - 1 || j == m - 1) {
				tbc.push({ mp[i][j], {i, j} });
			}
		}
	while (!tbc.empty())
		bfs(mp, ans);
	ll res = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			if (ans[i][j] != e9 + 1)
				res += ans[i][j] - mp[i][j];
	cout << res << "\n";
}