#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ull = unsigned long long;
const int base = 37;

ull bin_pow(int x, int n){
    if (!n) return 1;
    ull out = x, pr = x; n--;
    while (n > 0){
        if (n & 1){
            out *= pr;
        }
        pr *= pr;
        n >>= 1;
    }
    return out;
}

struct hash_str{
    vector<ull> pr;
    int n;
    hash_str(string s){
        n = (int) s.length();
        pr.resize(n + 1);
        pr[0] = 0;
        for (int i = 1; i <= n; i++){
            pr[i] = pr[i - 1] * base + (s[i - 1] - 'a' + 1);
        }
    }
    ull get(int l, int r){
        if (l > r) return 0;
        return pr[r] - pr[l - 1] * bin_pow(10, r - l);
    }
};

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    string s; cin>>s;
    int n = (int) s.length();
    hash_str T1(s);
    reverse(s.begin(), s.end());
    hash_str T2(s);
    ull h = 0;
    for (int i = 0; i < n; i++){
        int len = n + i;
        if (len % 2 == 0){
            int mid = len / 2;
            ull h1 = T2.get(1, mid);
            ull h2 = T1.get(1, mid - i) + bin_pow(base, mid - i) * h;
            if (h1 == h2){
                cout<<"Yes"<<"\n";
                return 0;
            }
        }
        else {
            int mid = len / 2 + 1;
            ull h1 = T2.get(1, mid - 1);
            ull h2 = T1.get(1, mid - i - 1) + bin_pow(base, mid - i - 1) * h;
            if (h1 == h2){
                cout<<"Yes"<<"\n";
                return 0;
            }
        }
        h = base * h + 1;
    }
}