#include <iostream>

using namespace std;

#define is_pike(row_max, col_max, row, col) (row_max)[(row)].second == col && (col_max)[(col)].second == row

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int height, width, queries;
    cin >> height >> width >> queries;

    pair<int, int>* row_max = new pair<int, int>[height];
    pair<int, int>* col_max = new pair<int, int>[width];

    memset(row_max, 0, height * sizeof(pair<int, int>));
    memset(col_max, 0, width * sizeof(pair<int, int>));

    for (int i = 0; i < height; i++) {
        for (int j = 0; j < width; j++) {
            int element;
            cin >> element;

            if (row_max[i].first < element) {
                row_max[i] = { element, j };
            }

            if (col_max[j].first < element) {
                col_max[j] = { element, i };
            }
        }
    }

    int pike_count = 0;

    for (int i = 0; i < height; i++) {
        for (int j = 0; j < width; j++) {
            pike_count += is_pike(row_max, col_max, i, j);
        }
    }

    for (int query = 0; query < queries; query++) {
        int row, col, value;
        cin >> row >> col >> value;

        row -= 1;
        col -= 1;

        bool was_pike = is_pike(row_max, col_max, row, col);

        if (row_max[row].first < value) {
            if (row_max[row].second != col && is_pike(row_max, col_max, row, row_max[row].second)) {
                pike_count -= 1;
            }

            row_max[row] = { value, col };
        }
        
        if (col_max[col].first < value) {
            if (col_max[col].second != col && is_pike(col_max, col_max, col_max[col].second, col)) {
                pike_count -= 1;
            }

            col_max[col] = { value, row };
        }

        if (!was_pike && is_pike(row_max, col_max, row, col)) {
            pike_count += 1;
        }

        cout << pike_count << "\n";
    }

    return 0;
}
